'mdInteger - by MOD
'20130921

'http://docs.oracle.com/javase/6/docs/api/java/lang/Integer.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Ifndef __MDINTEGER_BI__
#Define __MDINTEGER_BI__

Type mdInteger
	Public:
	Const As Integer MAX_VALUE = (2^31) - 1
	Const As Integer MIN_VALUE = -(2^31)
	Const As Integer SIZE = 32
	
	Declare Constructor ()
	Declare Constructor (value As Integer)
	Declare Constructor (value As mdInteger)
	Declare Constructor (s As String)
	
	'Declare Static Function bitCount(i As Integer) As Integer
	Declare Function byteValue() As Byte
	Declare Function compareTo(anotherInteger As mdInteger) As Integer
	Declare Static Function decode(nm As String) As mdInteger
	Declare Function doubleValue() As Double
	'Declare Function equals(obj As mdObject) As Boolean
	Declare Function equals(obj As mdInteger) As Boolean
	Declare Function floatValue() As Single
	Declare Function singleValue() As Single
	'Declare Static Function getInteger(nm As String) As mdInteger
	'Declare Static Function getInteger(nm As String, value As Integer) As mdInteger
	'Declare Static Function getInteger(nm As String, value As mdInteger) As mdInteger
	'Declare Function hashCode() As Integer
	'Declare Static Function highestOneBit(i As Integer) As Integer
	Declare Function intValue() As Integer
	Declare Function longValue() As Long
	'Declare Static Function lowestOneBit(i As Integer) As Integer
	'Declare Static Function numberOfLeadingZeros(i As Integer) As Integer
	'Declare Static Function numberOfTrailingZeros(i As Integer) As Integer
	Declare Static Function parseInt(s As String) As Integer
	'Declare Static Function parseInt(s As String, radix As Integer) As Integer
	'Declare Static Function reverse(i As Integer) As Integer
	Declare Static Function reverseBytes(i As Integer) As Integer
	Declare Static Function rotateLeft(i As Integer, distance As Integer) As Integer
	Declare Static Function rotateRight(i As Integer, distance As Integer) As Integer
	Declare Function shortValue() As Short
	Declare Static Function signum(i As Integer) As Integer
	Declare Static Function toBinaryString(i As Integer) As String
	Declare Static Function toHexString(i As Integer) As String
	Declare Static Function toOctalString(i As Integer) As String
	Declare Function toString() As String
	Declare Static Function toString(i As Integer) As String
	'Declare Static Function toString(i As Integer, radix As Integer) As String
	Declare Static Function valueOf(i As Integer) As mdInteger
	Declare Static Function valueOf(s As String) As mdInteger
	'Declare Static Function valueOf(s As String, radix As Integer) As mdInteger
	
	Declare Operator Cast() As Integer
	Declare Operator Cast() As String
	Declare Operator Let(value As Integer)
	Declare Operator Let(value As mdInteger)
	
	Private:
	As Integer<mdInteger.SIZE> dat
End Type

Constructor mdInteger ()
	This.dat = 0
End Constructor

Constructor mdInteger (value As Integer)
	This.dat = value
End Constructor

Constructor mdInteger (value As mdInteger)
	This.dat = value.intValue()
End Constructor

Constructor mdInteger (s As String)
	This.dat = ValInt(s)
End Constructor

'Function mdInteger.bitCount(i As Integer) As Integer
'	
'End Function

Function mdInteger.byteValue() As Byte
	Dim As Byte value = This.dat
	Return value
End Function

Function mdInteger.compareTo(anotherInteger As mdInteger) As Integer
	Return This.dat - anotherInteger.intValue()
End Function

Function mdInteger.decode(nm As String) As mdInteger
	Dim As mdInteger newmdInteger = ValInt(nm)
	Return newmdInteger
End Function

Function mdInteger.doubleValue() As Double
	Dim As Double value = This.dat
	Return value
End Function

'Function mdInteger.equals(obj As mdObject) As Boolean

Function mdInteger.equals(obj As mdInteger) As Boolean
	If @This = @obj Then
		Return TRUE
	Else
		Return FALSE
	EndIf
End Function

Function mdInteger.floatValue() As Single
	Dim As Single value = This.dat
	Return value
End Function

Function mdInteger.singleValue() As Single
	Return This.floatValue()
End Function

'Function mdInteger.getInteger(nm As String) As mdInteger
'	
'End Function
'
'Function mdInteger.getInteger(nm As String, value As Integer) As mdInteger
'	
'End Function
'
'Function mdInteger.getInteger(nm As String, value As mdInteger) As mdInteger
'	
'End Function

'Function mdInteger.hashCode() As Integer
'	
'End Function
'
'Function mdInteger.highestOneBit(i As Integer) As Integer
'	
'End Function

Function mdInteger.intValue() As Integer
	Dim As Integer value = This.dat
	Return value
End Function

Function mdInteger.longValue() As Long
	Dim As Long value = This.dat
	Return value
End Function

'Function mdInteger.lowestOneBit(i As Integer) As Integer
'	
'End Function
'
'Function mdInteger.numberOfLeadingZeros(i As Integer) As Integer
'	
'End Function
'
'Function mdInteger.numberOfTrailingZeros(i As Integer) As Integer
'	
'End Function

Function mdInteger.parseInt(s As String) As Integer
	Return ValInt(s)
End Function

'Function mdInteger.parseInt(s As String, radix As Integer) As Integer
'	
'End Function
'
'Function mdInteger.reverse(i As Integer) As Integer
'	
'End Function

Function mdInteger.reverseBytes(i As Integer) As Integer
	Dim As Integer part(1 To 4)
	part(1) = i And &hFF
	part(2) = (i Shr  8) And &hFF
	part(3) = (i Shr 16) And &hFF
	part(4) = (i Shr 24) And &hFF
	Return ((part(1) Shl 24) Or (part(2) Shl 16) Or (part(3) Shl 8) Or part(4))
End Function

Function mdInteger.rotateLeft(i As Integer, distance As Integer) As Integer
	Return ((i Shl distance) Or (i Shr (32 - distance)))
End Function

Function mdInteger.rotateRight(i As Integer, distance As Integer) As Integer
	Return ((i Shr (32 - distance)) Or (i Shl distance))
End Function

Function mdInteger.shortValue() As Short
	Dim As Short value = This.dat
	Return value
End Function

Function mdInteger.signum(i As Integer) As Integer
	Return Sgn(i)
End Function

Function mdInteger.toBinaryString(i As Integer) As String
	Return Bin(i)
End Function

Function mdInteger.toHexString(i As Integer) As String
	Return Hex(i)
End Function

Function mdInteger.toOctalString(i As Integer) As String
	Return Oct(i)
End Function

Function mdInteger.toString() As String
	Return IIf(This.dat >= 0, " ", "") & Str(This.dat)
End Function

Function mdInteger.toString(i As Integer) As String
	Return IIf(i >= 0, " ", "") & Str(i)
End Function

'Function mdInteger.toString(i As Integer, radix As Integer) As String
'	
'End Function

Function mdInteger.valueOf(i As Integer) As mdInteger
	Dim As mdInteger newmdInteger = i
	Return newmdInteger
End Function

Function mdInteger.valueOf(s As String) As mdInteger
	Dim As mdInteger newmdInteger = ValInt(s)
	Return newmdInteger
End Function

'Function mdInteger.valueOf(s As String, radix As Integer) As mdInteger
'	
'End Function

Operator mdInteger.Cast() As Integer
	Return This.dat
End Operator

Operator mdInteger.Cast() As String
	Return IIf(This.dat >= 0, " ", "") & Str(This.dat)
End Operator

Operator mdInteger.Let(value As Integer)
	this.dat = value
End Operator

Operator mdInteger.Let(value As mdInteger)
	this.dat = value.intValue()
End Operator

#EndIf '__MDINTEGER_BI__
