'mdList - by MOD
'20131101

'http://docs.oracle.com/javase/6/docs/api/java/util/List.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Define mdList(E) mdList##E
#Macro mdListDeclare(E)

#Ifndef mdBasicNode##E
'#Define __MBBASICNODE__

Type mdBasicNode##E
	nex As mdBasicNode##E Ptr
	value As E
End Type

#EndIf '__MBBASICNODE__

#Include Once "md/util/mdCollection.bi"
mdCollectionDeclare(E)

#Include Once "md/util/mdIterator.bi"
mdIteratorDeclare(E)

#Ifndef mdList##E
'#Define __MDLIST_BI__

Type mdList##E Extends mdCollection##E
	Public:
	Declare Constructor ()
	Declare Constructor (element As E)
	Declare Constructor (l As mdCollection##E)
	Declare Destructor ()
	
	Declare Function add(element As E) As Boolean
	Declare Function add(index As Integer, element As E) As Boolean
	Declare Function addAll(c As mdCollection##E) As Boolean
	Declare Function addAll(index As Integer, c As mdCollection##E) As Boolean
	Declare Sub clear()
	'Declare Function contains(o As mdObject) As Boolean
	Declare Function contains(o As E) As Boolean
	Declare Function containsAll(c As mdCollection##E) As Boolean
	Declare Function equals(o As mdCollection##E) As Boolean
	Declare Function get(index As Integer) As E
	Declare Function hashCode() As Integer
	'Declare Function indexOf(o As mdObject) As Integer
	Declare Function indexOf(o As E) As Integer
	Declare Function isEmpty() As Boolean
	Declare Function iterator() As mdIterator##E
	'Declare Function lastIndexOf(o As mdObject) As Integer
	Declare Function lastIndexOf(o As E) As Integer
	'Declare Function listIterator() As mdListIterator
	'Declare Function listIterator(index As Integer) As mdListIterator
	Declare Function remove(index As Integer) As E
	'Declare Function remove(o As mdObject) As Boolean
	Declare Function remove(o As E) As Boolean
	Declare Function removeAll(c As mdCollection##E) As Boolean
	Declare Function retainAll(c As mdCollection##E) As Boolean
	Declare Function set(index As Integer, element As E) As E
	Declare Function size() As Integer
	Declare Function subList(fromIndex As Integer, toIndex As Integer) As mdList##E
	Declare Function toArray(array() As E) As Boolean
	Declare Function toString() As String
	
	Declare Operator Cast() As Integer
	Declare Operator Cast() As String
	Declare Operator Let(c As mdCollection##E)
End Type

Constructor mdList##E ()
	
End Constructor

Constructor mdList##E (element As E)
	This.add(element)
End Constructor

Constructor mdList##E (l As mdCollection##E)
	This.addAll(l)
End Constructor

Destructor mdList##E ()
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		nextNode = currentNode->nex->nex
		Delete currentNode->nex
		currentNode->nex = nextNode
	Wend
End Destructor

Function mdList##E.add(element As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		currentNode = currentNode->nex
	Wend
	
	currentNode->nex = New mdBasicNode##E
	If currentNode->nex = NULL Then
		Return FALSE
	Else
		currentNode->nex->value = element
		Return TRUE
	EndIf
End Function

Function mdList##E.add(index As Integer, element As E) As Boolean
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode <> NULL
		If i = index Then
			Dim As mdBasicNode##E Ptr nextNode = currentNode->nex
			currentNode->nex = New mdBasicNode##E
			If currentNode->nex = NULL Then
				currentNode->nex = nextNode
				Return FALSE
			Else
				currentNode->nex->value = element
				currentNode->nex->nex = nextNode
				Return TRUE
			EndIf
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	
	Return FALSE
End Function

Function mdList##E.addAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

Function mdList##E.addAll(index As Integer, c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = 0 To UBound(temp)
		This.add(index + i, temp(i))
	Next
	Return TRUE
End Function

Sub mdList##E.clear()
	This.Destructor()
End Sub

Function mdList##E.contains(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdList##E.containsAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) = FALSE Then
			Return FALSE
		EndIf
	Next
	Return TRUE
End Function

Function mdList##E.equals(o As mdCollection##E) As Boolean
	If @This = @o Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdList##E.get(index As Integer) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i = index Then
			Return currentNode->nex->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Function mdList##E.hashCode() As Integer
	Dim As Integer hash = 1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		hash = 31 * hash + IIf(currentNode->nex = NULL, 0, Cast(UInteger, currentNode->nex) \ This.size())
		currentNode = currentNode->nex
	Wend
	Return hash
End Function

Function mdList##E.indexOf(o As E) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		i += 1
		If currentNode->nex->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Function mdList##E.isEmpty() As Boolean
	If This.size() = 0 Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdList##E.iterator() As mdIterator##E
	Dim As mdIterator##E newIterator = This.node.nex
	Return newIterator
End Function

Function mdList##E.lastIndexOf(o As E) As Integer
	Dim As Integer i = 0, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			retIndex = i
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Function mdList##E.remove(index As Integer) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If i = index Then
			Dim As E value = currentNode->nex->value
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
			Return value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Function mdList##E.remove(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
			Return TRUE
		EndIf
		
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdList##E.removeAll(c As mdCollection##E) As Boolean
	Dim As Integer cSize = c.size()
	
	If cSize = 0 Or This.size() = 0 Then
		Return FALSE
	EndIf
	
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) Then
			This.remove(temp(i))
		EndIf
	Next
	Return TRUE
End Function

Function mdList##E.retainAll(c As mdCollection##E) As Boolean
	Dim As Integer thisSize = This.size()
	
	If thisSize = 0 Or c.size() = 0 Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If c.contains(currentNode->nex->value) = FALSE Then
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
		EndIf
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdList##E.set(index As Integer, element As E) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i = index Then
			Dim As E value = currentNode->nex->value
			currentNode->nex->value = element
			Return value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Function mdList##E.size() As Integer
	Dim As Integer count = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

Function mdList##E.subList(fromIndex As Integer, toIndex As Integer) As mdList##E
	Dim As Integer i = 0
	Dim As mdList##E newmdList
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i >= fromIndex And i <= toIndex Then
			newmdList.add(currentNode->nex->value)
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return newmdList
End Function

Function mdList##E.toArray(array() As E) As Boolean
	Dim As Integer thisSize = This.size(), i = 0
	If thisSize = 0 Then
		Return FALSE
	EndIf
	
	ReDim array(0 To thisSize - 1)
	If @array(0) = NULL Then
		Return FALSE
	EndIf
	
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		array(i) = currentNode->nex->value
		i += 1
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdList##E.toString() As String
	Dim As String ret = "["
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		ret &= Str(currentNode->nex->value)
		currentNode = currentNode->nex
		If currentNode->nex <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "]"
	Return ret
End Function

Operator mdList##E.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdList##E.Cast() As String
	Return This.toString()
End Operator

Operator mdList##E.Let(c As mdCollection##E)
	This.clear()
	This.addAll(c)
End Operator

#EndIf '__MDLIST_BI__

#EndMacro
