'mdMap - by MOD
'20131101

'http://docs.oracle.com/javase/6/docs/api/java/util/Map.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Define mdMapEntry(K, V) mdMapEntry##K##V

#Define mdMap(K, V) mdMap##K##V
#Macro mdMapDeclare(K, V)

#Include Once "md/util/mdCollection.bi"
mdCollectionDeclare(V)
#Include Once "md/util/mdSet.bi"
mdSetDeclare(K)

#Ifndef mdMapEntry##K##V
'#Define __MDMAPENTRY__

Type mdMapEntry##K##V
	Public:
	Declare Constructor ()
	Declare Constructor (key As K, value As V)
	'Declare Function equals(o As mdObject) As Boolean
	Declare Function equals(o As mdMapEntry##K##V) As Boolean
	Declare Function getKey() As K
	Declare Function getValue() As V
	Declare Function hashCode() As Integer
	Declare Function setValue(value As V) As V
	Declare Function toString() As String
	
	Declare Operator Cast() As String
	
	Private:
	As K key
	As V value
End Type

Constructor mdMapEntry##K##V ()
	
End Constructor

Constructor mdMapEntry##K##V (key As K, value As V)
	This.key = key
	This.value = value
End Constructor

'Declare Function mdMapEntry##K##V.equals(o As mdObject) As Boolean

Function mdMapEntry##K##V.equals(o As mdMapEntry##K##V) As Boolean
	If o.getKey() = This.key And o.getValue() = This.value Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdMapEntry##K##V.getKey() As K
	Return This.key
End Function

Function mdMapEntry##K##V.getValue() As V
	Return This.value
End Function

Function mdMapEntry##K##V.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

Function mdMapEntry##K##V.setValue(value As V) As V
	Dim As V tempValue = This.value
	This.value = value
	Return tempValue
End Function

Function mdMapEntry##K##V.toString() As String
	Return Str(This.key) & "=" & Str(This.value)
End Function

Operator mdMapEntry##K##V.Cast() As String
	Return This.toString()
End Operator

Operator = (ByRef lhs As mdMapEntry(K, V), ByRef rhs As mdMapEntry(K, V)) As Integer
	Return @lhs = @rhs
End Operator

mdSetDeclare(mdMapEntry(K, V))

#EndIf '__MDMAPENTRY__

#Ifndef mdMapNode##K##V
'#Define __MDMAPNODE__

Type mdMapNode##K##V
	nex As mdMapNode##K##V Ptr
	value As mdMapEntry##K##V
End Type

#EndIf '__MDMAPNODE__

#Ifndef mdMap##K##V
'#Define __MDMAP_BI__

Type mdMap##K##V
	Public:
	Declare Constructor ()
	Declare Constructor (m As mdMap##K##V)
	Declare Destructor ()
	Declare Sub clear()
	'Declare Function containsKey(key As mdObject) As Boolean
	Declare Function containsKey(key As K) As Boolean
	'Declare Function containsValue(value As mdObject) As Boolean
	Declare Function containsValue(value As V) As Boolean
	Declare Function entrySet() As mdSet(mdMapEntry##K##V)
	'Declare Function equals(o As mdObject) As Boolean
	Declare Function equals(o As mdMap##K##V) As Boolean
	'Declare Function get(key As mdObject) As V
	Declare Function get(key As K) As V
	Declare Function hashCode() As Integer
	Declare Function isEmpty() As Boolean
	Declare Function keySet() As mdSet##K
	Declare Function put(key As K, value As V) As V
	Declare Sub putAll(m As mdMap##K##V)
	'Declare Function remove(key As mdObject) As V
	Declare Function remove(key As K) As V
	Declare Function size() As Integer
	Declare Function toString() As String
	Declare Function values() As mdCollection##V
	
	Declare Operator Cast() As Integer
	Declare Operator Cast() As String
	Declare Operator Let(c As mdMap##K##V)
	
	Private:
	node As mdMapNode##K##V
	
End Type

Constructor mdMap##K##V ()
	
End Constructor

Constructor mdMap##K##V (m As mdMap##K##V)
	This.putAll(m)
End Constructor

Destructor mdMap##K##V ()
	Dim As mdMapNode##K##V Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		nextNode = currentNode->nex->nex
		Delete currentNode->nex
		currentNode->nex = nextNode
	Wend
End Destructor

Sub mdMap##K##V.clear()
	This.Destructor()
End Sub

'Function mdMap##K##V.containsKey(key As mdObject) As Boolean

Function mdMap##K##V.containsKey(key As K) As Boolean
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value.getKey() = key Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

'Function mdMap##K##V.containsValue(value As mdObject) As Boolean

Function mdMap##K##V.containsValue(value As V) As Boolean
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value.getValue() = value Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdMap##K##V.entrySet() As mdSet(mdMapEntry##K##V)
	Dim As mdSet(mdMapEntry##K##V) newmdSet
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		newmdSet.add(currentNode->nex->value)
		currentNode = currentNode->nex
	Wend
	Return newmdSet
End Function

'Function mdMap##K##V.equals(o As mdObject) As Boolean

Function mdMap##K##V.equals(o As mdMap##K##V) As Boolean
	If @This = @o Then
		Return TRUE
	EndIf
	Return FALSE
End Function

'Function mdMap##K##V.get(key As mdObject) As V

Function mdMap##K##V.get(key As K) As V
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value.getKey() = key Then
			Return currentNode->nex->value.getValue()
		EndIf
		currentNode = currentNode->nex
	Wend
	Dim As V emptyValue
	Return emptyValue
End Function

Function mdMap##K##V.hashCode() As Integer
	Return Cast(Integer, @This)
End Function

Function mdMap##K##V.isEmpty() As Boolean
	If This.size() = 0 Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdMap##K##V.keySet() As mdSet##K
	Dim As mdSet##K newSet
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		newSet.add(currentNode->nex->value.getKey())
		currentNode = currentNode->nex
	Wend
	Return newSet
End Function

Function mdMap##K##V.put(key As K, value As V) As V
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value.getKey() = key Then
			Dim As V tempValue = currentNode->nex->value.getValue(), unusedValue
			unusedValue = currentNode->nex->value.setValue(value)
			Return tempValue
		EndIf
		currentNode = currentNode->nex
	Wend
	
	Dim As mdMapEntry##K##V Ptr newEntry = New mdMapEntry##K##V(key, value)
	currentNode = @This.node
	While currentNode->nex <> NULL
		currentNode = currentNode->nex
	Wend
	
	currentNode->nex = New mdMapNode##K##V
	If currentNode->nex = NULL Then
	Else
		currentNode->nex->value = *newEntry
	EndIf
	Dim As V emptyValue
	Return emptyValue
End Function

Sub mdMap##K##V.putAll(m As mdMap##K##V)
	Dim As mdSet##K newSet = m.keySet()
	Dim As mdCollection##V newCollection = m.values()
	Dim As V valueArray()
	newCollection.toArray(valueArray())
	
	Dim As Integer i = 0
	Dim As V tempValue
	Dim As K key
	ForEach (K, key In newSet)
		tempValue = This.put(key, valueArray(i))
		i += 1
	NextEach
End Sub

'Function mdMap##K##V.remove(key As mdObject) As V

Function mdMap##K##V.remove(key As K) As V
	Dim As mdMapNode##K##V Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If currentNode->nex->value.getKey() = key Then
			Dim As V tempValue = currentNode->nex->value.getValue()
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
			Return tempValue
		EndIf
		
		currentNode = currentNode->nex
	Wend
	Dim As V emptyValue
	Return emptyValue
End Function

Function mdMap##K##V.size() As Integer
	Dim As Integer count = 0
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

Function mdMap##K##V.toString() As String
	Dim As String ret = "{"
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		ret &= Str(currentNode->nex->value)
		currentNode = currentNode->nex
		If currentNode->nex <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "}"
	Return ret
End Function

Function mdMap##K##V.values() As mdCollection##V
	Dim As mdCollection##V newCollection
	Dim As mdMapNode##K##V Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		newCollection.add(currentNode->nex->value.getValue())
		currentNode = currentNode->nex
	Wend
	Return newCollection
End Function

Operator mdMap##K##V.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdMap##K##V.Cast() As String
	Return This.toString()
End Operator

Operator mdMap##K##V.Let(c As mdMap##K##V)
	This.clear()
	This.putAll(c)
End Operator

#EndIf '__MDMAP_BI__

#EndMacro
