'mdSet - by MOD
'20131101

'http://docs.oracle.com/javase/6/docs/api/java/util/Set.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Define mdSet(E) mdSet##E
#Macro mdSetDeclare(E)

#Ifndef mdBasicNode##E
'#Define __MBBASICNODE__

Type mdBasicNode##E
	nex As mdBasicNode##E Ptr
	value As E
End Type

#EndIf '__MBBASICNODE__

#Include Once "md/util/mdCollection.bi"
mdCollectionDeclare(E)

#Include Once "md/util/mdIterator.bi"
mdIteratorDeclare(E)

#Ifndef mdSet##E
'#Define __MDSET_BI__

Type mdSet##E Extends mdCollection##E
	Public:
	Declare Constructor ()
	Declare Constructor (element As E)
	Declare Constructor (s As mdCollection##E)
	Declare Destructor ()
	Declare Function add(element As E) As Boolean
	Declare Function addAll(c As mdCollection##E) As Boolean
	Declare Sub clear()
	'Declare Function contains(o As mdObject) As Boolean
	Declare Function contains(o As E) As Boolean
	Declare Function containsAll(c As mdCollection##E) As Boolean
	Declare Function equals(o As mdCollection##E) As Boolean
	Declare Function hashCode() As Integer
	Declare Function isEmpty() As Boolean
	Declare Function iterator() As mdIterator##E
	'Declare Function remove(o As mdObject) As Boolean
	Declare Function remove(o As E) As Boolean
	Declare Function removeAll(c As mdCollection##E) As Boolean
	Declare Function retainAll(c As mdCollection##E) As Boolean
	Declare Function size() As Integer
	'Declare Function toArray(array() As mdObject) As Boolean
	Declare Function toArray(array() As E) As Boolean
	Declare Function toString() As String
	
	Declare Operator Cast() As Integer
	Declare Operator Cast() As String
	Declare Operator Let(c As mdCollection##E)
End Type

Constructor mdSet##E ()
	
End Constructor

Constructor mdSet##E (element As E)
	This.add(element)
End Constructor

Constructor mdSet##E (s As mdCollection##E)
	This.addAll(s)
End Constructor

Destructor mdSet##E ()
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
    While currentNode->nex <> NULL
    	nextNode = currentNode->nex->nex
        Delete currentNode->nex
        currentNode->nex = nextNode
    Wend
End Destructor

Function mdSet##E.add(element As E) As Boolean
	If This.contains(element) Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E Ptr currentNode = @This.node
    While currentNode->nex <> NULL
        currentNode = currentNode->nex
    Wend
    
    currentNode->nex = New mdBasicNode##E
    If currentNode->nex = NULL Then
        Return FALSE
    Else
        currentNode->nex->value = element
        Return TRUE
    EndIf
End Function

Function mdSet##E.addAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

Sub mdSet##E.clear()
	This.Destructor()
End Sub

'Function mdSet##E.contains(o As mdObject) As Boolean

Function mdSet##E.contains(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdSet##E.containsAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) = FALSE Then
			Return FALSE
		EndIf
	Next
	Return TRUE
End Function

Function mdSet##E.equals(o As mdCollection##E) As Boolean
	If @This = @o Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdSet##E.hashCode() As Integer
	Dim As Integer hash = 1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
    While currentNode->nex <> NULL
    	hash = 31 * hash + IIf(currentNode->nex = NULL, 0, Cast(UInteger, currentNode->nex) \ This.size())
    	currentNode = currentNode->nex
    Wend
    Return hash
End Function

Function mdSet##E.isEmpty() As Boolean
	If This.size() = 0 Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdSet##E.iterator() As mdIterator##E
	Dim As mdIterator##E newIterator = This.node.nex
	Return newIterator
End Function

'Function mdSet##E.remove(o As mdObject) As Boolean

Function mdSet##E.remove(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
    While currentNode->nex <> NULL
    	If currentNode->nex->value = o Then
    		nextNode = currentNode->nex->nex
    		Delete currentNode->nex
    		currentNode->nex = nextNode
    		Return TRUE
    	EndIf
    	
        currentNode = currentNode->nex
    Wend
    Return FALSE
End Function

Function mdSet##E.removeAll(c As mdCollection##E) As Boolean
	Dim As Integer cSize = c.size()
	
	If cSize = 0 Or This.size() = 0 Then
		Return FALSE
	EndIf
	
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) Then
			This.remove(temp(i))
		EndIf
	Next
	Return TRUE
End Function

Function mdSet##E.retainAll(c As mdCollection##E) As Boolean
	Dim As Integer thisSize = This.size()
	
	If thisSize = 0 Or c.size() = 0 Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If c.contains(currentNode->nex->value) = FALSE Then
			nextNode = currentNode->nex->nex
    		Delete currentNode->nex
    		currentNode->nex = nextNode
		EndIf
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdSet##E.size() As Integer
	Dim As Integer count = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

'Function mdSet##E.toArray(array() As mdObject) As Boolean

Function mdSet##E.toArray(array() As E) As Boolean
	Dim As Integer thisSize = This.size(), i = 0
	If thisSize = 0 Then
		Return FALSE
	EndIf
	
	ReDim array(0 To thisSize - 1)
	If @array(0) = NULL Then
		Return FALSE
	EndIf
	
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		array(i) = currentNode->nex->value
		i += 1
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdSet##E.toString() As String
	Dim As String ret = "["
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		ret &= Str(currentNode->nex->value)
		currentNode = currentNode->nex
		If currentNode->nex <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "]"
	Return ret
End Function

Operator mdSet##E.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdSet##E.Cast() As String
	Return This.toString()
End Operator

Operator mdSet##E.Let(c As mdCollection##E)
	This.clear()
	This.addAll(c)
End Operator

#EndIf '__MDSET_BI__

#EndMacro
