'mdVector - by MOD
'20131101

'http://docs.oracle.com/javase/6/docs/api/java/util/Vector.html


#Ifndef Boolean
	#Define Boolean Integer
#EndIf
#Ifndef FALSE
	#Define FALSE 0
	#Define TRUE (Not FALSE)
#EndIf
#Ifndef NULL
	#Define NULL CPtr(Any Ptr, 0)
#EndIf

#Define mdVector(E) mdVector##E
#Macro mdVectorDeclare(E)

#Ifndef mdBasicNode##E
'#Define __MBBASICNODE__

Type mdBasicNode##E
	nex As mdBasicNode##E Ptr
	value As E
End Type

#EndIf '__MBBASICNODE__

#Include Once "md/util/mdList.bi"
mdListDeclare(E)

#Include Once "md/util/mdIterator.bi"
mdIteratorDeclare(E)

#Ifndef mdVector##E
'#Define __MDVECTOR_BI__

Type mdVector##E Extends mdList##E
	Public:
	Declare Constructor ()
	Declare Constructor (element As E)
	Declare Constructor (l As mdCollection##E)
	Declare Destructor ()
	
	Declare Function add(element As E) As Boolean
	Declare Function add(index As Integer, element As E) As Boolean
	Declare Function addAll(c As mdCollection##E) As Boolean
	Declare Function addAll(index As Integer, c As mdCollection##E) As Boolean
	Declare Sub addElement(element As E)
	Declare Function capacity() As Integer
	Declare Sub clear()
	'Declare Function clone() As mdObject
	Declare Function clone() As mdVector##E Ptr
	'Declare Function contains(o As mdObject) As Boolean
	Declare Function contains(o As E) As Boolean
	Declare Function containsAll(c As mdCollection##E) As Boolean
	Declare Sub copyInto(anArray() As E)
	Declare Function elementAt(index As Integer) As E
	'Declare Function elements() As mdEnumeration##E
	Declare Sub ensureCapacity(minCapacity As Integer)
	Declare Function equals(o As mdCollection##E) As Boolean
	Declare Function firstElement() As E
	Declare Function get(index As Integer) As E
	Declare Function hashCode() As Integer
	'Declare Function indexOf(o As mdObject) As Integer
	Declare Function indexOf(o As E) As Integer
	Declare Function indexOf(o As E, index As Integer) As Integer
	Declare Sub insertElementAt(o As E, index As Integer)
	Declare Function isEmpty() As Boolean
	Declare Function iterator() As mdIterator##E
	Declare Function lastElement() As E
	'Declare Function lastIndexOf(o As mdObject) As Integer
	Declare Function lastIndexOf(o As E) As Integer
	Declare Function lastIndexOf(o As E, index As Integer) As Integer
	'Declare Function listIterator() As mdListIterator
	'Declare Function listIterator(index As Integer) As mdListIterator
	Declare Function remove(index As Integer) As E
	'Declare Function remove(o As mdObject) As Boolean
	Declare Function remove(o As E) As Boolean
	Declare Function removeAll(c As mdCollection##E) As Boolean
	Declare Sub removeAllElements()
	Declare Function removeElement(obj As E) As Boolean
	Declare Sub removeElementAt(index As Integer)
	Declare Function retainAll(c As mdCollection##E) As Boolean
	Declare Function set(index As Integer, element As E) As E
	Declare Sub setElementAt(element As E, index As Integer)
	Declare Sub setSize(newSize As Integer)
	Declare Function size() As Integer
	Declare Function subList(fromIndex As Integer, toIndex As Integer) As mdList##E
	Declare Function toArray(array() As E) As Boolean
	Declare Function toString() As String
	Declare Sub trimToSize()
	
	Declare Operator Cast() As Integer
	Declare Operator Cast() As String
	Declare Operator Let(c As mdCollection##E)
	
	'Protected:
	Declare Sub removeRange(fromIndex As Integer, toIndex As Integer)
End Type

Constructor mdVector##E ()
	
End Constructor

Constructor mdVector##E (element As E)
	This.add(element)
End Constructor

Constructor mdVector##E (l As mdCollection##E)
	This.addAll(l)
End Constructor

Destructor mdVector##E ()
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		nextNode = currentNode->nex->nex
		Delete currentNode->nex
		currentNode->nex = nextNode
	Wend
End Destructor

Function mdVector##E.add(element As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		currentNode = currentNode->nex
	Wend
	
	currentNode->nex = New mdBasicNode##E
	If currentNode->nex = NULL Then
		Return FALSE
	Else
		currentNode->nex->value = element
		Return TRUE
	EndIf
End Function

Function mdVector##E.add(index As Integer, element As E) As Boolean
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode <> NULL
		If i = index Then
			Dim As mdBasicNode##E Ptr nextNode = currentNode->nex
			currentNode->nex = New mdBasicNode##E
			If currentNode->nex = NULL Then
				currentNode->nex = nextNode
				Return FALSE
			Else
				currentNode->nex->value = element
				currentNode->nex->nex = nextNode
				Return TRUE
			EndIf
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	
	Return FALSE
End Function

Function mdVector##E.addAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = LBound(temp) To UBound(temp)
		This.add(temp(i))
	Next
	Return TRUE
End Function

Function mdVector##E.addAll(index As Integer, c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	If @temp(0) = NULL Then
		Return FALSE
	EndIf
	For i As Integer = 0 To UBound(temp)
		This.add(index + i, temp(i))
	Next
	Return TRUE
End Function

Sub mdVector##E.addElement(element As E)
	This.add(element)
End Sub

Function mdVector##E.capacity() As Integer
	Return -1 'the representation of this vector is a linked list, not an array, so capacity = RAM
End Function

Sub mdVector##E.clear()
	This.Destructor()
End Sub

Function mdVector##E.clone() As mdVector##E Ptr
	Dim As mdVector##E Ptr retVector = New mdVector##E
	For i As Integer = 0 To This.size() - 1
		retVector->add(This.get(i))
	Next
	Return retVector
End Function

Function mdVector##E.contains(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			Return TRUE
		EndIf
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdVector##E.containsAll(c As mdCollection##E) As Boolean
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) = FALSE Then
			Return FALSE
		EndIf
	Next
	Return TRUE
End Function

Sub mdVector##E.copyInto(anArray() As E)
	This.toArray(anArray())
End Sub

Function mdVector##E.elementAt(index As Integer) As E
	Return This.get(index)
End Function

Sub mdVector##E.ensureCapacity(minCapacity As Integer)
	'see This.capacity()
End Sub

Function mdVector##E.equals(o As mdCollection##E) As Boolean
	If @This = @o Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdVector##E.firstElement() As E
	Return This.get(0)
End Function

Function mdVector##E.get(index As Integer) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i = index Then
			Return currentNode->nex->value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Function mdVector##E.hashCode() As Integer
	Dim As Integer hash = 1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		hash = 31 * hash + IIf(currentNode->nex = NULL, 0, Cast(UInteger, currentNode->nex) \ This.size())
		currentNode = currentNode->nex
	Wend
	Return hash
End Function

Function mdVector##E.indexOf(o As E) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		i += 1
		If currentNode->nex->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Function mdVector##E.indexOf(o As E, index As Integer) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		i += 1
		If i >= index AndAlso currentNode->nex->value = o Then
			retIndex = i
			Exit While
		EndIf
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Sub mdVector##E.insertElementAt(o As E, index As Integer)
	This.add(index, o)
End Sub

Function mdVector##E.isEmpty() As Boolean
	If This.size() = 0 Then
		Return TRUE
	EndIf
	Return FALSE
End Function

Function mdVector##E.iterator() As mdIterator##E
	Dim As mdIterator##E newIterator = This.node.nex
	Return newIterator
End Function

Function mdVector##E.lastElement() As E
	Return This.get(This.size() - 1)
End Function

Function mdVector##E.lastIndexOf(o As E) As Integer
	Dim As Integer i = 0, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			retIndex = i
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Function mdVector##E.lastIndexOf(o As E, index As Integer) As Integer
	Dim As Integer i = -1, retIndex = -1
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i >= index AndAlso currentNode->nex->value = o Then
			retIndex = i
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return retIndex
End Function

Function mdVector##E.remove(index As Integer) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If i = index Then
			Dim As E value = currentNode->nex->value
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
			Return value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Function mdVector##E.remove(o As E) As Boolean
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If currentNode->nex->value = o Then
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
			Return TRUE
		EndIf
		
		currentNode = currentNode->nex
	Wend
	Return FALSE
End Function

Function mdVector##E.removeAll(c As mdCollection##E) As Boolean
	Dim As Integer cSize = c.size()
	
	If cSize = 0 Or This.size() = 0 Then
		Return FALSE
	EndIf
	
	Dim As E temp()
	c.toArray(temp())
	For i As Integer = LBound(temp) To UBound(temp)
		If This.contains(temp(i)) Then
			This.remove(temp(i))
		EndIf
	Next
	Return TRUE
End Function

Sub mdVector##E.removeAllElements()
	This.clear()
End Sub

Function mdVector##E.removeElement(obj As E) As Boolean
	Return This.remove(obj)
End Function

Sub mdVector##E.removeElementAt(index As Integer)
	Dim As E tempE = This.remove(index)
End Sub

Function mdVector##E.retainAll(c As mdCollection##E) As Boolean
	Dim As Integer thisSize = This.size()
	
	If thisSize = 0 Or c.size() = 0 Then
		Return FALSE
	EndIf
	Dim As mdBasicNode##E Ptr currentNode = @This.node, nextNode
	While currentNode->nex <> NULL
		If c.contains(currentNode->nex->value) = FALSE Then
			nextNode = currentNode->nex->nex
			Delete currentNode->nex
			currentNode->nex = nextNode
		EndIf
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdVector##E.set(index As Integer, element As E) As E
	Dim As Integer i = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i = index Then
			Dim As E value = currentNode->nex->value
			currentNode->nex->value = element
			Return value
		EndIf
		
		i += 1
		currentNode = currentNode->nex
	Wend
	Dim As E tempRet
	Return tempRet
End Function

Sub mdVector##E.setElementAt(element As E, index As Integer)
	Dim As E tempE = This.set(index, element)
End Sub

Sub mdVector##E.setSize(newSize As Integer)
	'see this.capacity()
End Sub

Function mdVector##E.size() As Integer
	Dim As Integer count = 0
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		count += 1
		currentNode = currentNode->nex
	Wend
	Return count
End Function

Function mdVector##E.subList(fromIndex As Integer, toIndex As Integer) As mdList##E
	Dim As Integer i = 0
	Dim As mdList##E newmdList
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		If i >= fromIndex And i <= toIndex Then
			newmdList.add(currentNode->nex->value)
		EndIf
		i += 1
		currentNode = currentNode->nex
	Wend
	Return newmdList
End Function

Function mdVector##E.toArray(array() As E) As Boolean
	Dim As Integer thisSize = This.size(), i = 0
	If thisSize = 0 Then
		Return FALSE
	EndIf
	
	ReDim array(0 To thisSize - 1)
	If @array(0) = NULL Then
		Return FALSE
	EndIf
	
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		array(i) = currentNode->nex->value
		i += 1
		currentNode = currentNode->nex
	Wend
	Return TRUE
End Function

Function mdVector##E.toString() As String
	Dim As String ret = "["
	Dim As mdBasicNode##E Ptr currentNode = @This.node
	While currentNode->nex <> NULL
		ret &= Str(currentNode->nex->value)
		currentNode = currentNode->nex
		If currentNode->nex <> NULL Then
			ret &= ", "
		EndIf
	Wend
	ret &= "]"
	Return ret
End Function

Sub mdVector##E.trimToSize()
	'see This.capacity()
End Sub

Operator mdVector##E.Cast() As Integer
	Return This.hashCode()
End Operator

Operator mdVector##E.Cast() As String
	Return This.toString()
End Operator

Operator mdVector##E.Let(c As mdCollection##E)
	This.clear()
	This.addAll(c)
End Operator

Sub mdVector##E.removeRange(fromIndex As Integer, toIndex As Integer)
	Dim As E tempE
	For i As Integer = toIndex - 1 To fromIndex Step -1
		tempE = This.remove(i)
	Next
End Sub

#EndIf '__MDVECTOR_BI__

#EndMacro
